/* -*- Mode: c++; -*- */
/*  --------------------------------------------------------------------
 *  Filename:
 *    src/greeting.cc
 *  
 *  Description:
 *    Implementation of the inital greeting.
 *
 *  Authors:
 *    Andreas Aardal Hanssen <bincimap@andreas.hanssen.name>
 *
 *  Bugs:
 *
 *  ChangeLog:
 *
 *  --------------------------------------------------------------------
 *  Copyright 2002, 2003 Andreas Aardal Hanssen
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Street #330, Boston, MA 02111-1307, USA.
 *  --------------------------------------------------------------------
 */
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <time.h>

#include "io/io.h"

using namespace ::std;
using namespace Binc;

#ifdef VERSION
const string version = VERSION;
#else
const string version = "";
#endif

static const unsigned int ISO8601SIZE = 32;

namespace Binc {
  bool showGreeting(void);
};


//------------------------------------------------------------------------
bool Binc::showGreeting(void)
{
  IO &com = IOFactory::getInstance().get(1);
  IO &logger = IOFactory::getInstance().get(2);

  time_t t = time(NULL);
  struct tm *mytm = localtime(&t);

  // the longest string strftime can generate using this format string
  // is YYYY-MM-DDTHH:MM:SS+NNNN, which is 24 characters.
  char mytime[ISO8601SIZE];
  unsigned int size = strftime(mytime, sizeof(mytime),
			       "%Y-%m-%dT%I:%M:%S%z", mytm);
  if (size >= sizeof(mytime)) {
    logger << "problem formatting system time" << endl;
    return false;
  }
  
  com << "* OK Welcome to Binc IMAP v" << version 
      << " (c) Copyright 2002, 2003 Andreas Aardal Hanssen at "
      << mytime << endl;

  return true;
}
